apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ recordings_name }}
    backups.opsperator.io/service: backups-{{ recordings_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ recordings_name }}
  name: {{ recordings_name }}
  namespace: {{ namespace }}
spec:
  replicas: 1
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ recordings_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ recordings_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ recordings_name }}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ recordings_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ recordings_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: BEHIND_PROXY
          value: "true"
        - name: DATABASE_URL
          valueFrom:
            secretKeyRef:
              key: database-url
              name: {{ slpg_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HOME
          value: /srv/scalelite
        - name: LOADBALANCER_SECRET
          valueFrom:
            secretKeyRef:
              key: loadbalancer-key
              name: {{ scalelite_name }}
        - name: NGINX_SSL
          value: "false"
        - name: RECORDING_IMPORT_POLL
          value: "false"
        - name: REDIS_URL
          value: redis://{{ cache_name }}-proxy:6379
        - name: SECRET_KEY_BASE
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ scalelite_name }}
        - name: TZ
          value: {{ timezone }}
        - name: URL_HOST
          value: scalelite.{{ root_domain }}
{% if do_triggers == False or (opsimages | json_query("[?name=='scalelite_importer'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='scalelite_importer'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: importer
        resources:
          limits:
            cpu: "{{ scalelite_importer_cpu_limit }}"
            memory: "{{ scalelite_importer_memory_limit }}"
          requests:
            cpu: "{{ scalelite_importer_cpu_request }}"
            memory: "{{ scalelite_importer_memory_request }}"
        volumeMounts:
        - mountPath: /srv/scalelite/tmp
          name: temp
          subPath: sctemp
        - mountPath: /usr/local/share/ca-certificates
          name: pkiconf
        - mountPath: /var/bigbluebutton
          name: recordings
        - mountPath: /var/bigbluebutton/spool
          name: recordings
          subPath: spool
{% if do_backups %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 30
{% else %}
          failureThreshold: 5
{% endif %}
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 30
          tcpSocket:
            port: 2222
{% endif %}
        volumeMounts:
        - mountPath: /backups
          name: recordings
        - mountPath: /home/backup
          name: temp
          subPath: bkphome
        - mountPath: /var/backup
          name: temp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ recordings_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: recordings
        persistentVolumeClaim:
          claimName: {{ scalelite_name }}
{% if (k8s_flavor != 'openshift' and tls_provider == 'internalca') or (bigbluebutton_ca_bundle | default([])) | length > 0 %}
      - name: pkiconf
        projected:
          sources:
{% if k8s_flavor != 'openshift' and tls_provider == 'internalca' %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% if (bigbluebutton_ca_bundle | default([])) | length > 0 %}
{% for cert in bigbluebutton_ca_bundle %}
          - configMap:
              items:
              - key: bigbluebutton-chain{{ loop.index0 }}.crt
                path: bigbluebutton-chain{{ loop.index0 }}.crt
              name: {{ scalelite_name }}
{% endfor %}
{% endif %}
{% else %}
      - emptyDir: {}
        name: pkiconf
{% endif %}
{% if do_backups %}
      - name: ssh
        secret:
          secretName: backups-{{ scalelite_name }}
{% endif %}
      - emptyDir: {}
        name: temp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='scalelite_importer'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - importer
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='scalelite_importer'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
    type: ImageChange
{% endif %}
  - type: ConfigChange
{% endif %}
